// extPrintDlg.js: Example GUI script for BrainVoyager QX 2.1
// This script bundle consists of extPrintDlg.js and extPrintDlg.ui, place both in /Documents/BVQXExtensions/Scripts/ folder.
// Functionality: The script will print input from the widgets to the BrainVoyager QX log tab if the button with label 'print input' and name 'btnPrint' is clicked.
// Some widgets will emit signals, and also print their input to the BrainVoyager QX log tab.
// Usage: In the BrainVoyager menu, select 'Scripts' > 'Edit and Run Scripts...' and click 'Load...' to load this script, then 'Run'.
// HB, BI, 2010.

var scriptObj 					= new Object; 
scriptObj.scriptNameForUser 	= "GUIScriptDemo"; 
scriptObj.dialogFileName 		= "extPrintDlg.ui"; 
scriptObj.dialogAccessName 	= "printDlg"; // this name 'printDlg' is used in the rest of the script to address the widgets
BrainVoyagerQX.PrintToLog("Script started...");

// in the initDlg() function below, this function is connected to btnPrint from extPrintDlg.ui
scriptObj.collectInput = function() { 

	BrainVoyagerQX.PrintToLog("Script> Push button clicked, collected input:"); 
    	BrainVoyagerQX.PrintToLog("Script> Line edit: " 		+ this.printDlg.lnEditPrint.text);
	BrainVoyagerQX.PrintToLog("Script> Combo box: " 		+ this.printDlg.cmBoxPrint.currentText + ", index: " + this.printDlg.cmBoxPrint.currentIndex);
	BrainVoyagerQX.PrintToLog("Script> Text edit: " 		+ this.printDlg.txtEditPrint.plainText);
	BrainVoyagerQX.PrintToLog("Script> Time edit: " 		+ this.printDlg.tmEditPrint.time);
	BrainVoyagerQX.PrintToLog("Script> Date edit: " 		+ this.printDlg.dtEditPrint.date);
      BrainVoyagerQX.PrintToLog("Script> Spinbox: " 			+ this.printDlg.spnBoxPrint.value); 
      BrainVoyagerQX.PrintToLog("Script> Double spinbox: " 	+ this.printDlg.dSpnBoxPrint.value); 
}

scriptObj.printFromRadioButton = function() {
  if (this.printDlg.radioBtnPrint.checked) {
        BrainVoyagerQX.PrintToLog("Script> Radio button changed to checked");
    } else {
        BrainVoyagerQX.PrintToLog("Script> Radio button changed to unchecked");    
    }
}

scriptObj.printFromCheckBox = function() {
    if (this.printDlg.chkBoxPrint.checked) {
        BrainVoyagerQX.PrintToLog("Script> Check box changed to checked");
    } else {
        BrainVoyagerQX.PrintToLog("Script> Check box changed to unchecked");    
    }
}

scriptObj.printFromComboBox = function() {
    var currentItemIndex = this.printDlg.cmBoxPrint.currentIndex;
    var currentItemText = this.printDlg.cmBoxPrint.currentText;
    BrainVoyagerQX.PrintToLog("Script> Print from combobox, current index: " + currentItemIndex + ", current text: " + currentItemText);
}

scriptObj.printFromLineEdit = function() {
    var textInLineEdit = this.printDlg.lnEditPrint.text;
    BrainVoyagerQX.PrintToLog("Script> Print from line edit, new text: " + textInLineEdit);
}

scriptObj.printFromTextEdit = function() {
	var newText =  this.printDlg.txtEditPrint.plainText;
	BrainVoyagerQX.PrintToLog("Script> Print from text edit, new text: " + newText);
}

scriptObj.initDlg = function() { 

    this.printDlg.windowTitle = "extended print dialog"; 

    // connect all the widgets to functions here
    this.printDlg.btnPrint.clicked.connect(this, this.collectInput); // this is the button from the extPrintDlg.ui 
    this.printDlg.radioBtnPrint.toggled.connect(this, this.printFromRadioButton);
    this.printDlg.chkBoxPrint.stateChanged.connect(this, this.printFromCheckBox);
    this.printDlg.lnEditPrint.editingFinished.connect(this, this.printFromLineEdit); 
    this.printDlg.txtEditPrint.textChanged.connect(this, this.printFromTextEdit); // prints after input of each character

}

returnScriptObj = function() { 
	return scriptObj; 
} 
returnScriptObj(); // should be after returnScriptOjb = function()
